require "import"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "java.util.Random"

local DialogInterface = luajava.bindClass("android.content.DialogInterface")

local function guessTheNumber()
    local numberToGuess = math.random(1, 100)
    local attempts = 0

    local alertDialog = AlertDialog.Builder(activity)
    alertDialog.setTitle("Guess the Number")
    alertDialog.setMessage("Try to guess the number between 1 and 100")

    local input = EditText(activity)
    input.setInputType(2) -- InputType.TYPE_CLASS_NUMBER
    alertDialog.setView(input)

    alertDialog.setPositiveButton("Guess", DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            local userInput = tonumber(input.getText().toString())
            if userInput == nil or userInput < 1 or userInput > 100 then
err("Error!", "Please input the valid numbers.", "Ok")
            else
                attempts = attempts + 1
                if userInput < numberToGuess then
err("Aw!", "Too low! Try again", "Try Again")
                elseif userInput > numberToGuess then
err("oow", "Too high! try again.", "Try again")
                else
err("Congratulations!", "You guessed the number in "..attempts.." attempts. Do you want to try again?", "Yes")
                end
            end
        end
    })

    alertDialog.setNegativeButton("Cancel", nil)
    alertDialog.show()
end

function err(t, m, b)
local dlg = AlertDialog.Builder()
dlg.setTitle(t)
dlg.setMessage(m)
dlg.setPositiveButton(b, {onClick=function()
guessTheNumber()
end})
dlg.show()
end

guessTheNumber()